using Tekla.Structures;
using Tekla.Structures.Model;
using Tekla.Structures.Solid;
using Tekla.Structures.Geometry3d;
using T3D = Tekla.Structures.Geometry3d;
using TSM = Tekla.Structures.Model;
using TSMUI = Tekla.Structures.Model.UI;
namespace Tekla.Technology.Akit.UserScript
{
    public class Script
    {
        public static void Run(Tekla.Technology.Akit.IScript akit)
        {
            Model Model = new Model();
            TransformationPlane CurrentPlane = Model.GetWorkPlaneHandler().GetCurrentTransformationPlane();
            Model.GetWorkPlaneHandler().SetCurrentTransformationPlane(new TransformationPlane());

            TSMUI.ModelObjectSelector ColumnSelector = new TSMUI.ModelObjectSelector();
            ModelObjectEnumerator SelectedColumns = ColumnSelector.GetSelectedObjects();
            TSMUI.GraphicsDrawer Drawer = new TSMUI.GraphicsDrawer();

            if (SelectedColumns.GetSize() > 0)
            {
                TSM.Operations.Operation.DisplayPrompt(" .....");
                while (SelectedColumns.MoveNext())
                {
                    Part Column = SelectedColumns.Current as Part;
                    if (Column != null)
                    {
                        Model.GetWorkPlaneHandler().SetCurrentTransformationPlane(new TransformationPlane(Column.GetCoordinateSystem()));
                        Drawer.DrawLineSegment(new LineSegment(new T3D.Point(0, 0, 0), new T3D.Point(500, 0, 0)), new TSMUI.Color(0, 1, 0));
                        Drawer.DrawText(new T3D.Point(250, 0, 0), " X", new TSMUI.Color(0, 0, 0));
                        Drawer.DrawLineSegment(new LineSegment(new T3D.Point(0, 0, 0), new T3D.Point(0, 500, 0)), new TSMUI.Color(1, 0, 0));
                        Drawer.DrawText(new T3D.Point(0, 250, 0), " Y", new TSMUI.Color(0, 0, 0));
                        Drawer.DrawLineSegment(new LineSegment(new T3D.Point(0, 0, 0), new T3D.Point(0, 0, 500)), new TSMUI.Color(0, 0, 1));
                        Drawer.DrawText(new T3D.Point(0, 0, 250), " Z", new TSMUI.Color(0, 0, 0));
                        Model.GetWorkPlaneHandler().SetCurrentTransformationPlane(new TransformationPlane());
                    }
                }
                TSM.Operations.Operation.DisplayPrompt("  ");
            }
            else
            {
                TSM.Operations.Operation.DisplayPrompt("    ");
            }

            Model.GetWorkPlaneHandler().SetCurrentTransformationPlane(CurrentPlane);
            Model.CommitChanges();
        }
    }
}
